Index: src/conf/constants.py
===================================================================
--- src/conf/constants.py	(revision a9f322be3fef0a77e1636ffea4d61a463722a52a)
+++ src/conf/constants.py	(revision 1a8904da7678286fb5c4edb2b013ff567110b5c2)
@@ -31,5 +31,7 @@
 # TextEdit Height
 CSNStextMaximumHeight=26
+CSNStextMaximumWidth = 100
 CSNStextMinimumHeight=10
+CSNStextMinimumWidth = 140
 
 # Table Height
Index: src/viewer/chopperSetting.py
===================================================================
--- src/viewer/chopperSetting.py	(revision 1a8904da7678286fb5c4edb2b013ff567110b5c2)
+++ src/viewer/chopperSetting.py	(revision 1a8904da7678286fb5c4edb2b013ff567110b5c2)
@@ -0,0 +1,243 @@
+#!/usr/bin/python
+# -*- coding: utf-8 -*-
+
+# configure
+
+'''
+Created on 2015.12.29
+
+ChopperSetting
+'''
+
+from conf.constants import *
+
+
+class CSNSChopperSetting(QtGui.QDialog):
+
+    def __init__(self):
+        super(CSNSChopperSetting, self).__init__(parent=None)
+        self.setupUi(self)
+
+    def setupUi(self, QDialog):
+        self.setWindowTitle('Chopper Setting')
+
+        self.mainGrid = QtGui.QGridLayout(self)
+
+        self.dc1Label = QtGui.QLabel('<font color=red>DC1</font>')
+        self.dc1PositionLabel = \
+            QtGui.QLabel('<font color=black>Position:</font>')
+        self.dc1PositionTextEdit = QtGui.QTextEdit('0.1')
+        self.dc1PositionTextEdit.setMaximumHeight(CSNStextMaximumHeight)
+        self.dc1PositionTextEdit.setMaximumWidth(CSNStextMaximumWidth)
+        self.dc1OpeningAngelLabel = \
+            QtGui.QLabel('<font color=black>Opening Angel:</font>')
+        self.dc1OpeningAngelTextEdit = QtGui.QTextEdit('0.1')
+        self.dc1OpeningAngelTextEdit.setMaximumHeight(CSNStextMaximumHeight)
+        self.dc1OpeningAngelTextEdit.setMaximumWidth(CSNStextMaximumWidth)
+
+        self.dc2Label = QtGui.QLabel('<font color=red>DC2</font>')
+        self.dc2PositionLabel = \
+            QtGui.QLabel('<font color=black>Position:</font>')
+        self.dc2PositionTextEdit = QtGui.QTextEdit('0.1')
+        self.dc2PositionTextEdit.setMaximumHeight(CSNStextMaximumHeight)
+        self.dc2PositionTextEdit.setMaximumWidth(CSNStextMaximumWidth)
+        self.dc2OpeningAngelLabel = \
+            QtGui.QLabel('<font color=black>Opening Angel:</font>')
+        self.dc2OpeningAngelTextEdit = QtGui.QTextEdit('0.1')
+        self.dc2OpeningAngelTextEdit.setMaximumHeight(CSNStextMaximumHeight)
+        self.dc2OpeningAngelTextEdit.setMaximumWidth(CSNStextMaximumWidth)
+
+        self.dc3Label = QtGui.QLabel('<font color=red>DC3</font>')
+        self.dc3PositionLabel = \
+            QtGui.QLabel('<font color=black>Position:</font>')
+        self.dc3PositionTextEdit = QtGui.QTextEdit('0.1')
+        self.dc3PositionTextEdit.setMaximumHeight(CSNStextMaximumHeight)
+        self.dc3PositionTextEdit.setMaximumWidth(CSNStextMaximumWidth)
+        self.dc3OpeningAngelLabel = \
+            QtGui.QLabel('<font color=black>Opening Angel:</font>')
+        self.dc3OpeningAngelTextEdit = QtGui.QTextEdit('0.1')
+        self.dc3OpeningAngelTextEdit.setMaximumHeight(CSNStextMaximumHeight)
+        self.dc3OpeningAngelTextEdit.setMaximumWidth(CSNStextMaximumWidth)
+
+        self.sampleLabel = QtGui.QLabel('<font color=red>Sample</font>')
+        self.samplePositionLabel = \
+            QtGui.QLabel('<font color=black>Position:</font>')
+        self.samplePositionTextEdit = QtGui.QTextEdit('0.1')
+        self.samplePositionTextEdit.setMaximumHeight(CSNStextMaximumHeight)
+        self.samplePositionTextEdit.setMaximumWidth(CSNStextMaximumWidth)
+
+        self.cancelButton = QtGui.QPushButton('Cancel')
+        self.okButton = QtGui.QPushButton('OK')
+
+        nrow = -1
+        nrow = nrow + 1
+        self.mainGrid.addWidget(
+            self.dc1Label,
+            nrow,
+            0,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        nrow = nrow + 1
+        self.mainGrid.addWidget(
+            self.dc1PositionLabel,
+            nrow,
+            0,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        self.mainGrid.addWidget(
+            self.dc1PositionTextEdit,
+            nrow,
+            1,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        self.mainGrid.addWidget(
+            self.dc1OpeningAngelLabel,
+            nrow,
+            2,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        self.mainGrid.addWidget(
+            self.dc1OpeningAngelTextEdit,
+            nrow,
+            3,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        nrow = nrow + 1
+        self.mainGrid.addWidget(
+            self.dc2Label,
+            nrow,
+            0,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        nrow = nrow + 1
+        self.mainGrid.addWidget(
+            self.dc2PositionLabel,
+            nrow,
+            0,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        self.mainGrid.addWidget(
+            self.dc2PositionTextEdit,
+            nrow,
+            1,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        self.mainGrid.addWidget(
+            self.dc2OpeningAngelLabel,
+            nrow,
+            2,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        self.mainGrid.addWidget(
+            self.dc2OpeningAngelTextEdit,
+            nrow,
+            3,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        nrow = nrow + 1
+        self.mainGrid.addWidget(
+            self.dc3Label,
+            nrow,
+            0,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        nrow = nrow + 1
+        self.mainGrid.addWidget(
+            self.dc3PositionLabel,
+            nrow,
+            0,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        self.mainGrid.addWidget(
+            self.dc3PositionTextEdit,
+            nrow,
+            1,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        self.mainGrid.addWidget(
+            self.dc3OpeningAngelLabel,
+            nrow,
+            2,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        self.mainGrid.addWidget(
+            self.dc3OpeningAngelTextEdit,
+            nrow,
+            3,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        nrow = nrow + 1
+        self.mainGrid.addWidget(
+            self.sampleLabel,
+            nrow,
+            0,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        nrow = nrow + 1
+        self.mainGrid.addWidget(
+            self.samplePositionLabel,
+            nrow,
+            0,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        self.mainGrid.addWidget(
+            self.samplePositionTextEdit,
+            nrow,
+            1,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        nrow = nrow + 1
+        self.mainGrid.addWidget(
+            self.cancelButton,
+            nrow,
+            2,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+        self.mainGrid.addWidget(
+            self.okButton,
+            nrow,
+            3,
+            1,
+            1,
+            QtCore.Qt.AlignLeft,
+            )
+
+
Index: src/viewer/menuBar.py
===================================================================
--- src/viewer/menuBar.py	(revision 23ffb363623057f4809b838ddcbbe9a214fab100)
+++ src/viewer/menuBar.py	(revision 1a8904da7678286fb5c4edb2b013ff567110b5c2)
@@ -19,5 +19,5 @@
 #from model.diffractionSimulator import *
 from viewer.canvas import *
-#from viewer.chopperSetting import *
+from viewer.chopperSetting import *
 #from viewer.serverSetting import *
 